// XmlIOServer
#include "xmlioserver.hpp"

#include "attribute_template_impl.hpp"
#include "group_template_impl.hpp"

#include "client.hpp"
#include "server.hpp"

#include "fake.hpp"

// Point d'entrée du programme principal
int main(int argc, char ** argv, char ** UNUSED(env))
{
   try
   {
      ARRAY_CREATE(value0, double, 1, [200]);
      ARRAY_CREATE(value1, double, 1, [1000]);
      ARRAY_CREATE(value2, double, 1, [2000]);
      comm::CMPIManager::Initialise(&argc, &argv); // < seulement en mode connecté
      
      if (comm::CMPIManager::IsMaster(comm::CMPIManager::GetCommWorld()))
      {
         comm::CServer server(comm::CMPIManager::GetCommWorld());
         server.run();
         std::cout << "fin serveur" << std::endl;
         comm::CMPIManager::Barrier();
         
      }
      else
      {
         
         comm::CClient client(comm::CMPIManager::GetCommWorld());
         client.initialize();
         client.setContext("lol");
         
         for (int j = 0; j < 10000; j++)
         {
            client.updateCalendar(j);
            client.sendData("mon_champ0", value0);
            client.sendData("mon_champ1", value1);
            client.sendData("mon_champ2", value2);
         }
         client.finalize();
         comm::CMPIManager::Barrier();
      }
      
      comm::CMPIManager::Finalize(); // < seulement en mode connecté
      
     
      /*CXIOSManager::Initialise(CXIOSManager::CLIENT_SERVER, &argc, &argv);
      
      CXIOSManager::AddClient("nemo"    , 4, 2, &nemo_fake_entry);
      //CXIOSManager::AddClient("orchidee", 1, 1, &orchidee_fake_entry);
      //CXIOSManager::AddClient("lmdz"    , 4, 2, &lmdz_fake_entry);
      CXIOSManager::RunClientServer(comm::CMPIManager::GetCommWorld());
      CXIOSManager::Finalize();*/
      
      

   }
   catch (CException & exc)
   {
      std::cerr << exc.getMessage() << std::endl;
      CMPIManager::Finalize();
      return (EXIT_FAILURE);
   }
   return (EXIT_SUCCESS);
}

